#include <stdlib.h>
#include <stdio.h>
#include <mpi.h>

#define buffsize 65536

int main(int argc, char* argv[])
{
	int				taskid, ntasks;
	int				i;
	int				*sendbuff, *recvbuff;
	double			inittime, totaltime;
	MPI_Request		sendrequest, recvrequest;
	int				done;

	MPI_Init(&argc, &argv);

	MPI_Comm_rank(MPI_COMM_WORLD, &taskid);
	MPI_Comm_size(MPI_COMM_WORLD, &ntasks);

	if (ntasks != 2)
	{
		printf("Program zahteva natanko dva procesa!!!\n");
		MPI_Finalize();
		exit(1);
	}

	sendbuff = (int *)malloc(sizeof(int)*buffsize);
	recvbuff = (int *)malloc(sizeof(int)*buffsize);

	for (i = 0; i<buffsize; i++)
		sendbuff[i] = i;

	MPI_Barrier(MPI_COMM_WORLD);
	inittime = MPI_Wtime();

	int size;


	MPI_Sendrecv(sendbuff, buffsize, MPI_INT, (taskid + 1) % 2, 0, 
				 recvbuff, buffsize, MPI_INT, (taskid + 1) % 2, MPI_ANY_TAG, 
				MPI_COMM_WORLD, MPI_STATUS_IGNORE);
	
	MPI_Barrier(MPI_COMM_WORLD);
	totaltime = MPI_Wtime() - inittime;

	if (taskid == 0)
		printf("Cas prenosa: %f s, buffsize: %ld\n", totaltime, sizeof(int)*buffsize);

	free(recvbuff);
	free(sendbuff);

	MPI_Finalize();

	return 0;
}
